PlayerCc::ActArrayProxy Class Reference
Proxies

The `ActArrayProxy` class is used to control a actarray device. More...

`#include <playerc++.h>`

Inheritance diagram for PlayerCc::ActArrayProxy:

## Public Member Functions

| ActArrayProxy (PlayerClient *aPc, uint32_t aIndex=0)
| Default constructor.
| ~ActArrayProxy ()
| Default destructor.
void | RequestGeometry (void)
| Geometry request - call before getting the geometry of a joint through the accessor method.
void | SetPowerConfig (bool aVal)
| Power control.
void | SetBrakesConfig (bool aVal)
| Brakes control.
void | SetSpeedConfig (uint32_t aJoint, float aSpeed)
| Speed control.
void | MoveTo (uint32_t aJoint, float aPos)
| Send an actuator to a position.
void | MoveToMulti (std::vector< float > aPos)
| Send actuators 0 thru n to the designated positions.
void | MoveAtSpeed (uint32_t aJoint, float aSpeed)
| Move an actuator at a speed.
void | MoveAtSpeedMulti (std::vector< float > aSpeed)
| Move actuators 0 thru n at the designated speeds.
void | MoveHome (int aJoint)
| Send an actuator, or all actuators, home.
void | SetActuatorCurrent (uint32_t aJoint, float aCurrent)
| Set an actuator to a given current.
void | SetActuatorCurrentMulti (std::vector< float > aCurrent)
| Set actuators 0 thru n to the given currents.
uint32_t | GetCount (void) const
| Gets the number of actuators in the array.
player_actarray_actuator_t | GetActuatorData (uint32_t aJoint) const
| Accessor method for getting an actuator's data.
player_actarray_actuatorgeom_t | GetActuatorGeom (uint32_t aJoint) const
| Same again for getting actuator geometry.
player_point_3d_t | GetBasePos (void) const
| Accessor method for getting the base position.
player_orientation_3d_t | GetBaseOrientation (void) const
| Accessor method for getting the base orientation.
player_actarray_actuator_t | operator[] (uint32_t aJoint)
| Actuator data access operator. More...
Public Member Functions inherited from PlayerCc::ClientProxy
bool | IsValid () const
| Returns true if we have received any data from the device.
bool | IsFresh () const
| Fresh is set to true on each new read. More...
void | NotFresh ()
| This states that the data in a client is currently not Fresh.
std::string | GetDriverName () const
| Returns the driver name. More...
double | GetDataTime () const
| Returns the received timestamp [s].
double | GetElapsedTime () const
| Returns the received timestamp [s].
PlayerClient * | GetPlayerClient () const
| Returns a pointer to the Player Client.
uint32_t | GetIndex () const
| Returns device index.
uint32_t | GetInterface () const
| Returns device interface.
std::string | GetInterfaceStr () const
| Returns device interface.
void | SetReplaceRule (bool aReplace, int aType=-1, int aSubtype=-1)
| Set a replace rule for this proxy on the server. More...
int | HasCapability (uint32_t aType, uint32_t aSubtype)
| Request capabilities of device. More...
int | GetBoolProp (char *aProperty, bool *aValue)
| Request a boolean property.
int | SetBoolProp (char *aProperty, bool aValue)
| Set a boolean property.
int | GetIntProp (char *aProperty, int32_t *aValue)
| Request an integer property.
int | SetIntProp (char *aProperty, int32_t aValue)
| Set an integer property.
int | GetDblProp (char *aProperty, double *aValue)
| Request a double property.
int | SetDblProp (char *aProperty, double aValue)
| Set a double property.
int | GetStrProp (char *aProperty, char **aValue)
| Request a string property.
int | SetStrProp (char *aProperty, char *aValue)
| Set a string property.
template<typename T >
connection_t | ConnectReadSignal (T aSubscriber)
| Connect a signal to this proxy For more information check out Signals & multithreading.
void | DisconnectReadSignal (connection_t aSubscriber)
| Disconnect a signal to this proxy.

## Private Member Functions

void | Subscribe (uint32_t aIndex)
void | Unsubscribe ()

## Private Attributes

playerc_actarray_t * | mDevice

## Additional Inherited Members

Public Types inherited from PlayerCc::ClientProxy
typedef int | connection_t
typedef boost::mutex::scoped_lock | scoped_lock_t
typedef int | read_signal_t
Protected Member Functions inherited from PlayerCc::ClientProxy
| ClientProxy (PlayerClient *aPc, uint32_t aIndex)
template<typename T >
T | GetVar (const T &aV) const
template<typename T >
void | GetVarByRef (const T aBegin, const T aEnd, T aDest) const
Protected Attributes inherited from PlayerCc::ClientProxy
PlayerClient * | mPc
playerc_client_t * | mClient
playerc_device_t * | mInfo
bool | mFresh

## Detailed Description

The `ActArrayProxy` class is used to control a actarray device.

## Member Function Documentation

player_actarray_actuator_t PlayerCc::ActArrayProxy::operator[] | ( | uint32_t | aJoint | ) |

inline

Actuator data access operator.

This operator provides an alternate way of access the actuator data. For example, given a `ActArrayProxy` named `ap`, the following expressions are equivalent: `ap.GetActuatorData`[0] and `ap`[0].

The documentation for this class was generated from the following file:

- playerc++.h

Last updated 12 September 2005 21:38:45